﻿using DragDropDemo.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DragDropDemo.ViewModel
{
    public class SongViewModel : ViewModelBase
    {
        public Song SongModel { get; set; }

        public SongViewModel(Song songModel, List<OrganisationListViewModel> OrganisationLists)
        {
            SongModel = songModel;
            AviableOrganisationLists = OrganisationLists;

            Name = SongModel.Name;
            Interpret = SongModel.Interpret;
            Album = SongModel.Album;

            ID = SongModel.ID;
            Comment = SongModel.Comment;
            CreatedBy = SongModel.CreatedBy;
            CreationTimeStamp = SongModel.CreationTimeStamp;
            LastModifiedBy = SongModel.LastModifiedBy;
            LastModifiedTimeStamp = SongModel.LastModifiedTimeStamp;

            OrganisationList = OrganisationLists.Where(x => x.ID == songModel.OrganisationListID).FirstOrDefault();
        }


        public string Name
        {
            get { return SongModel.Name; }
            set { SongModel.Name = value; RaisePropertyChanged(); }
        }
        public string Interpret
        {
            get { return SongModel.Interpret; }
            set { SongModel.Interpret = value; RaisePropertyChanged(); }
        }
        public string Album
        {
            get { return SongModel.Album; }
            set { SongModel.Album = value; RaisePropertyChanged(); }
        }

        #region ModelBase
        //ModelBase
        public Guid ID
        {
            get { return SongModel.ID; }
            set { SongModel.ID = value; RaisePropertyChanged(); }
        }
        public string Comment
        {
            get { return SongModel.Comment; }
            set { SongModel.Comment = value; RaisePropertyChanged(); }
        }
        public string CreatedBy
        {
            get { return SongModel.CreatedBy; }
            set { SongModel.CreatedBy = value; RaisePropertyChanged(); }
        }
        public DateTime CreationTimeStamp
        {
            get { return SongModel.CreationTimeStamp; }
            set { SongModel.CreationTimeStamp = value; RaisePropertyChanged(); }
        }
        public string LastModifiedBy
        {
            get { return SongModel.LastModifiedBy; }
            set { SongModel.LastModifiedBy = value; RaisePropertyChanged(); }
        }
        public DateTime LastModifiedTimeStamp
        {
            get { return SongModel.LastModifiedTimeStamp; }
            set { SongModel.LastModifiedTimeStamp = value; RaisePropertyChanged(); }
        }
        //End ModelBase
        #endregion

        public List<OrganisationListViewModel> AviableOrganisationLists { get; }

 

        private OrganisationListViewModel _OrganisationList;
        public OrganisationListViewModel OrganisationList
        {
            get { return _OrganisationList; }
            set { _OrganisationList = value; SongModel.OrganisationListID = value.ID; RaisePropertyChanged(); }
        }
    }
}
